angular.module('flashy.CardGridController', ['ui.router', 'ngAnimate', 'ngWebSocket', 'flashy.DeckFactory']).CardGridController =
    function($scope, $rootScope, $state, $http, $window, $timeout, $stateParams, $websocket, $interval, UserService, Flashcard, Deck) {
        sectionId = parseInt($stateParams.sectionId);
        $scope.cards = []; // all cards
        $scope.cardCols = []; // organized data
        $scope.affectedCards = []; // cards affected by a position change move
        $scope.numCols = 0;
        $scope.height = 0; // height of a card
		$scope.section = $rootScope.SectionResource.get({sectionId: sectionId});
        $scope.deck = new Deck(sectionId, {
            cardHideCallback: function(card) {
                $scope.hideCardFromGrid(card);
            }
        });

        Flashcard.linkDeck($scope.deck);

        $scope.moveQueue = [];

        $scope.procQueue;
        $scope.addMove = function(m) {
            if (!$scope.moveQueue) return m.go();
            $scope.moveQueue.push(m);
        };

        $scope.showGrid = false;
        //$scope.moveQueue = []; // queue of flashcard objects
        $rootScope.currentSection = $scope.section;

        $scope.refreshColumnWidth = function() {
            avail = $window.innerWidth - 17;
            width = Math.floor(avail / Math.floor(avail / 250));
            $('.cardColumn').css({
                width: width + 'px'
            });
            $('.cardColumn .card.flashy').css({
                width: width - 12 + 'px',
                'font-size': 100 * width / 250 + '%',
                height: (width * 3 / 5) + 'px'
            });
            $('.cardColumn .card.flashy i.small').css({
                'font-size': 200 * width / 250 + '%'
            });
            $('.cardColumn .card.flashy i.medium').css({
                'font-size': 400 * width / 250 + '%'
            });
			$scope.height = width * 3 / 5;
        };

        $scope.refreshLayout = function() {
            numCols = Math.max(1, Math.floor(($window.innerWidth - 17) / 250));

            // check if we actually need to refresh the whole layout
            if (numCols == $scope.numCols) return $scope.refreshColumnWidth();
            $scope.numCols = numCols;
            console.log('refreshing layout for ' + numCols + ' columns');
            $scope.cardCols = [];
            var cols = [];
            for (var i = 0; i < numCols; i++) cols.push([]);
            var n = 0;
            $scope.cards.forEach(function(card, j) {
                card.colNum = n++ % numCols;
                cols[card.colNum].push(card);
            });
            for (i in cols) $scope.updateColRanks(cols[i]);
            console.log(cols);
            return $timeout(function() {
                $scope.cardCols = cols;
                $timeout($scope.refreshColumnWidth);
            });
        };

        angular.element($window).bind('resize', $scope.refreshLayout);

        $scope.addCardToGrid = function(card) {
            var colNum = 0;
            var lowestCol = $scope.cardCols[0];
            var lowestColNum = 0;
            while (colNum < $scope.numCols) {
                if ($scope.cardCols[colNum].length == 0) {
                    lowestCol = $scope.cardCols[colNum];
                    break;
                } else if ($scope.cardCols[colNum].length < lowestCol.length) {
                    lowestCol = $scope.cardCols[colNum];
                    lowestColNum = colNum;
                    lowestColLen = $scope.cardCols[colNum].length;
                }
                colNum++;
            }
            console.log(card);
            $scope.cards.push(data);
            lowestCol.unshift(card);
            card.colNum = lowestColNum;
            $scope.updateColRanks(lowestCol);
            $timeout($scope.refreshColumnWidth);

        };

        $scope.updateColRanks = function(col) {
            for (i in col)
                col[i].colRank = parseInt(i);
        };

        $scope.hideCardFromGrid = function(card) {
            console.log('hiding', card);
            $scope.cardCols[card.colNum].splice(card.colRank, 1);
            $scope.updateColRanks($scope.cardCols[card.colNum]);
            console.log($scope.cardCols);
        };

        $scope.$on('$destroy', function() {
            $scope.deck.cleanup();
            Flashcard.cleanup();
            $rootScope.currentSection = {};
            $(document).off('keydown');
        });
        return $scope.deck.deckPromise;
    };
