angular.module('flashy.DeckFactory', ['ui.router', 'flashy.FlashcardFactory', 'ngWebSocket']).
    factory('Deck', function ($http, $rootScope, $state, $websocket, Flashcard, UserService) {

        var Deck = function (sectionId, callbacks) {
            if (!UserService.isInSection(sectionId)) {
                console.log('user is not enrolled in ' + sectionId);
                $state.go('addclass');
            }
            obj = this;
            this.cards = [];
            this.section = $rootScope.SectionResource.get({sectionId: sectionId});

            this.ws = $websocket($rootScope.ws_host + '/ws/deck/' + sectionId + '?subscribe-user');
            this.contains = function (id) {
                return this.cards[id];
            };

            this.ws.onMessage(function (message) {
                data = JSON.parse(message.data);
                console.log('message', data);
                card = new Flashcard(data.flashcard);
                if (data.event_type == 'card_pulled') {
                    obj.cards[card.id] = card;
                    if (callbacks.cardPullCallback) callbacks.cardPullCallback(card);
                }
                if (data.event_type == 'card_unpulled') {
                    obj.cards[card.id] = undefined;
                    if (callbacks.cardUnpullCallback) callbacks.cardUnpullCallback(card);
                }
                if (data.event_type == 'card_hidden') {
                    if (callbacks.cardHideCallback) callbacks.cardHideCallback(card);
                }
                if (data.event_type == 'card_unhidden') {
                    if (callbacks.cardUnhideCallback) callbacks.cardUnhideCallback(card);
                }
            });
            this.deckPromise = $http.get('/api/sections/' + sectionId + '/deck/').success(function (data) {
                for (i in data) obj.cards[data[i].id] = new Flashcard(data[i], obj);
                console.log("got user's deck", data);
            });
            this.cleanup = function () {
                this.ws.close();
            };
            this.forEach = this.cards.forEach;
        };

        return Deck;
    });